// {f[^TCY
#define MaxArea   2000	// qɍőTCY(Width*Height)
#define MaxBoxes     8	// BOX̍ől
#define MaxTrace 20000	// g[Xf[^ő
#define BuffSize  2000	// t@Cobt@TCY

// p[cR[h
#define FLOOR    0	//       0
#define GOAL     1	// .     1
#define BOX      2	// $    10
#define BOXGOAL  3	// *    11
#define MAN      4	// @   100
#define MANGOAL  5	// +   101
#define WALL     8	// #  1000
#define OUTSIDE 16	//   10000 (IWi)

// ^Cg
char *Title = "Sokoban MinimumMovesSolver1.2 by takaken (Mar/2021)";

// COŌʃ[
int  BeginEnd = 1;		// 0:KpȂ 1:Œ1BOX𓮂

// Level Loader
char LevelFolder[] = "C:\\temp_soko\\";	// xi[tH_
char LevelName[50];		// xZbg
int  LevelVolume;		// xZbg萔
int  LevelMaxNum;		// xZbgőԍ

// Level Selector
int  LevelNumber;		// Ώۃ}bvԍ
int  LevelMap[MaxArea];	// Ώۃ}bvf[^(p[cR[h)
int  Width, Height;		// Ώۃ}bvTCY
int  Boxes, Area;		// @V@Area = Width * Height
int  Diff[4];			// אڃ}Ẍʒu

// Level Selector(_~[)
int  Wall[MaxArea];		// WALL (}bv)
int  Bmap[MaxArea];		// BOX  (}bv)
int  Gmap[MaxArea];		// GOAL (}bv)
int  Nmap[MaxArea];		// zu֎~ (}bv)
int  Mpos;				// MAN ̈ʒu
int  Bcnt;				// BOX ̌
int  Bits[MaxArea];		// }gbNX}bv (Boxes<=31)

//@Solver
int  Map[MaxArea];		// WALL + BOX (}bv)
int  Box[MaxBoxes];		// BOX  (ʒuXg)
int  Man;				// MAN  (l̈ʒu)
int  CANCEL;			// ~
int  UseSec;			// gp(b)

// Trace
int  Moves, Tout;		// , TraceOvertO
char Trace[MaxTrace];	// g[X
char Tchr[8][2] = {"u","l","d","r","U","L","D","R"};	//@g[X

// t@Cobt@
char FileBuff[BuffSize+1];

// ZƃL[
#define CE_SIZE 14000000	// C (Cellsgp\)
#define QH_SIZE   800000	// H (Queuegp\)
#define QW_SIZE       64	// W (Queue)
typedef struct cell {
    short  box[MaxBoxes];	// BOXʒu
    short  man;				// MANʒu
	short  move;			// Moves
    struct cell *prev;		// e|C^
} Cell;
#define CE_FULL (CE_SIZE + CE_SIZE / 5)	//   (Z̎->20%)
Cell Cells[CE_FULL];			// Z
Cell *Queue[QW_SIZE][QH_SIZE];	// L[(񎟌)
int  Qend[QW_SIZE];				//@V@VKo^ʒu
int  Qtop;						//@V@oʒu
int  Qnot;						//@V@x
int  QueCnt;					//@V@qǖʗ

// gpʒ
int  C_use, Q_use;

// 𔭌
int  MinMove;
int  FindMove;
Cell *FindPtr;

//***********************************************************************
// ėpyCg֐
//***********************************************************************
// hԂR[h, hԂ}bv
int  P_ID1, PMAP1[MaxArea];
int  P_ID2, PMAP2[MaxArea];

// hԂ
void PaintSub(int soko[], int pos0, int pmap[], int p_id)
{
	int  pos1, vect, qtop=0, qend=0;
	int  queue[MaxArea];

	pmap[pos0] = p_id;
	queue[qend++] = pos0;
	while (qtop < qend) {
		pos0 = queue[qtop++];
		for (vect=0; vect<4; vect++) {
			pos1 = pos0 + Diff[vect];
			if (!soko[pos1] && pmap[pos1]!=p_id) {
				pmap[pos1] = p_id;
				queue[qend++] = pos1;
			}
		}
	}
}
// soko[]̋ԗ̈ɑ΂āAPMAP2[]P_ID2œhԂ
void Paint2(int soko[], int pos)
{
	int  i;

	if (P_ID2 == INT_MAX) {
		for (i=0; i<MaxArea; i++) PMAP2[i] = 0;
		P_ID2 = 1;
	} else {
		P_ID2++;
	}
	PaintSub(soko, pos, PMAP2, P_ID2);
}
// soko[]̋ԗ̈ɑ΂āAPMAP1[]P_ID1œhԂ
void Paint1(int soko[], int pos)
{
	int  i;

	if (P_ID1 == INT_MAX) {
		for (i=0; i<MaxArea; i++) PMAP1[i] = 0;
		P_ID1 = 1;
	} else {
		P_ID1++;
	}
	PaintSub(soko, pos, PMAP1, P_ID1);
}
